'use strict';

exports.__esModule = true;

var _templateObject = _taggedTemplateLiteralLoose(['\n                ', '\n            '], ['\n                ', '\n            ']),
    _templateObject2 = _taggedTemplateLiteralLoose(['\n                    ', '\n                '], ['\n                    ', '\n                ']);

var _styledComponents = require('styled-components');

var _styledMediaQuery = require('styled-media-query');

var _styledMediaQuery2 = _interopRequireDefault(_styledMediaQuery);

var _lodash = require('lodash.clonedeep');

var _lodash2 = _interopRequireDefault(_lodash);

var _ThemeManager = require('./ThemeManager');

var _ThemeManager2 = _interopRequireDefault(_ThemeManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

var applyGenericTheme = function applyGenericTheme(themeNamespace) {
  return function (cssRules) {
    return function (_ref) {
      var theme = _ref.theme;

      // Get provided breakpoints
      var breakpoints = (0, _lodash2.default)(_ThemeManager2.default.getBreakpoints());

      // Get the theme properties
      var themeProps = theme[themeNamespace];
      var responsiveThemeProps = {};

      var maxValueLength = -Infinity;
      for (var _iterator = Object.entries(themeProps), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref3;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref3 = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref3 = _i.value;
        }

        var _ref2 = _ref3;
        var themeProp = _ref2[0];
        var value = _ref2[1];

        // Wrap simple values into an array for convenience
        var responsiveValue = value instanceof Array ? [].concat(value) : [value];

        maxValueLength = Math.max(maxValueLength, responsiveValue.length);
        responsiveThemeProps[themeProp] = responsiveValue;
      }

      var responsiveCssRules = [];

      // Generating all the required media queries
      for (var i = 0; i < maxValueLength; i++) {
        var currentBreakpoint = breakpoints.shift();
        var currentBreakpointProps = {};

        for (var _iterator2 = Object.entries(responsiveThemeProps), _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
          var _ref5;

          if (_isArray2) {
            if (_i2 >= _iterator2.length) break;
            _ref5 = _iterator2[_i2++];
          } else {
            _i2 = _iterator2.next();
            if (_i2.done) break;
            _ref5 = _i2.value;
          }

          var _ref4 = _ref5;
          var responsiveProp = _ref4[0];
          var responsiveValue = _ref4[1];

          currentBreakpointProps[responsiveProp] = typeof responsiveValue[i] !== 'undefined' ? responsiveValue[i] : responsiveValue[responsiveValue.length - 1];
        }

        if (i !== 0) {
          responsiveCssRules = [].concat(responsiveCssRules, (0, _styledComponents.css)(_templateObject, _styledMediaQuery2.default.greaterThan(currentBreakpoint)(_templateObject2, cssRules(currentBreakpointProps))));
        } else {
          responsiveCssRules = [].concat(responsiveCssRules, (0, _styledComponents.css)(_templateObject, cssRules(currentBreakpointProps)));
        }
      }

      return responsiveCssRules;
    };
  };
};

exports.default = applyGenericTheme;
module.exports = exports['default'];